#ifndef __SAMPLEGENERATOR_H
#define __SAMPLEGENERATOR_H


/** Class that generates samples on a circle
*/

struct Sample2
{
	Sample2() {}
	Sample2(float _x, float _y): x(_x), y(_y) {}

	float x; 
	float y;
};


class SampleGenerator
{
public:
	
	SampleGenerator(int numSamples, float radius);

	virtual void Generate(Sample2 *samples) const = 0;

protected:

	SampleGenerator() {};

	int mNumSamples;
	float mRadius;
};


class PoissonDiscSampleGenerator: public SampleGenerator
{
public:
	
	PoissonDiscSampleGenerator(int numSamples, float radius);

	virtual void Generate(Sample2 *samples) const;
};


class GaussianSampleGenerator: public SampleGenerator
{
public:
	
	GaussianSampleGenerator(int numSamples, float radius);

	virtual void Generate(Sample2 *samples) const;
};


class SphericalSampleGenerator: public SampleGenerator
{
public:
	
	SphericalSampleGenerator(int numSamples, float radius);

	virtual void Generate(Sample2 *samples) const;
};


#endif